/// <reference types="node" />
import type { Server } from 'net';
import * as Types from './interfaces';
export declare abstract class Kernel<Config extends Types.Configuration, App extends Types.App<any, any, any>, Container extends Types.Container> {
    protected app: App;
    protected container: Container;
    protected logger: Types.Logger;
    protected options: Config;
    protected server?: Server;
    constructor(options: Config);
    boot(): Promise<void>;
    serve(): Promise<void>;
    shutdown(): Promise<void>;
    protected createContainer(): Container;
    protected buildContainer(): Promise<void>;
    protected addMiddlewares(): void;
    protected createApp(): App;
    protected abstract createContainerBuilder(): Types.ContainerBuilder;
    protected getControllerPaths(): string;
    protected middlewares(): Types.AppMiddleware<any, any, any>[];
    protected abstract createLogger(): Types.Logger;
    protected loadControllers(): void;
    protected abstract getCWD(): string;
}
